package com.honeywell.hses.workflow.util;

import java.util.List;

import org.jbpm.task.User;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.ContentData;
import org.jbpm.task.service.TaskService;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.local.LocalTaskService;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

@Repository("humanTaskEngine")
@Transactional
public class HumanTaskEngine {

    private LocalTaskService taskService;
    
    private TaskService actTaskService;
    
    /*public void init(){
    	TaskServiceSession taskSession = actTaskService.createSession();
    	taskSession.addUser(new User("E2001"));
    	taskSession.addUser(new User("E123456"));
    	taskSession.addUser(new User("E1234"));
    }*/
    
    
    public List<TaskSummary> getTaskForUser(String user) {
        return taskService.getTasksAssignedAsPotentialOwner(user, "en-UK");
    }
    
    public List<TaskSummary> getTaskForAdmin(String user){
    	return taskService.getTasksAssignedAsBusinessAdministrator(user, "en-UK");
    }
    
    public void startTask(long taskId, String user) {
        taskService.start(taskId, user);
        
    }
    
    public void completeTask(long taskId, String user) {
        taskService.complete(taskId, user, null);
    }
    
    public void completeTask(long taskId, String user,ContentData cData) {
        taskService.complete(taskId, user, cData);
    }
    
    public void completeTaskWithResult(long taskId,String user,Object result){
    	taskService.completeWithResults(taskId, user, result);
    }

    public LocalTaskService getTaskService() {
        return taskService;
    }

    public void setTaskService(LocalTaskService taskService) {
        this.taskService = taskService;
    }


	public TaskService getActTaskService() {
		return actTaskService;
	}


	public void setActTaskService(TaskService actTaskService) {
		this.actTaskService = actTaskService;
	}
}
